package test

import (
	// "encoding/json"
	"fmt"
	"gdhsxy/hsxy"
	"gdhsxy/utils"
	"io"
	"regexp"
	"strings"
	"testing"
)

func TestFetch(t *testing.T) {
	base_url := "http://jwxt.gdhsc.edu.cn/jsxsd/framework/mainV_index_loadkb.htmlx"
	req := hsxy.BuildRequest(base_url)
	// fmt.Println(req)
	resp, err := hsxy.Fetch(req)
	if err != nil {
		fmt.Println(err)
	}
	body, err := io.ReadAll(resp.Body)
	fmt.Println(string(body))
	if err != nil {
		fmt.Println(err)
	}
}

func TestParse(t *testing.T) {
	s := new(hsxy.Schedule)
	sch := map[string]string{
		"周次小节": "星期一 01~02小节 第15周",
		"地点":   "厚德楼C-厚德楼C303大金融实验室",
		"教师":   "钟广玲",
		"课程名称": "Python程序设计",
	}

	fmt.Println(s.Parse(sch))
}
func TestParser(t *testing.T) {
	data, err := utils.ReadFile("../resource/schedule.html")

	if err != nil {
		fmt.Println(err)
	}

	re := regexp.MustCompile(`(?s)<tr align="center">(.*?)</tr>`)
	matches := re.FindAllString(string(data), -1)

	// 匹配字段
	nameCompile := regexp.MustCompile(`<p>([^<]+)</p><div class='tch-name'>`)
	teacherCompile := regexp.MustCompile(`</p><p>(.*?)</p><span class='text'>`)
	dateCompile := regexp.MustCompile(`<span class='text'>(.*?)</span></span>`)
	addrCompile := regexp.MustCompile(`<img src='/jsxsd/assets_v1/images/item1.png'>(.*?)</span><span>`)
	weekCompile := regexp.MustCompile(`<img src='/jsxsd/assets_v1/images/item3.png'>(.*?)</span></div><span style='display:none;' name='wkxx'>`)
	var result []string
	for _, matche := range matches {
		nameTemp := nameCompile.FindAllStringSubmatch(matche, -1)
		teacherTemp := teacherCompile.FindAllStringSubmatch(matche, -1)
		dateTemp := dateCompile.FindAllStringSubmatch(matche, -1)
		addrTemp := addrCompile.FindAllStringSubmatch(matche, -1)
		weekTemp := weekCompile.FindAllStringSubmatch(matche, -1)

		if len(nameTemp) > 1 {
			for i := 0; i < len(nameTemp); i++ {
				result = append(
					result,
					nameTemp[i][1],
					teacherTemp[i][1],
					dateTemp[i][1],
					addrTemp[i][1],
					weekTemp[i][1],
				)

			}
		}

	}
	fmt.Println(result)
}

func TestMap(t *testing.T) {

	var sTemp []string
	var resTemp []map[string]string
	var mTemp map[string]string
	var result map[string][]map[string]string

	data, err := utils.ReadFile("../resource/schedule.html")
	if err != nil {
		fmt.Println(err)
	}
	sechdule := hsxy.RawParse(string(data))
	result = make(map[string][]map[string]string)

	var time string
	const key = "sch"

	for i := 0; i <= len(sechdule); i++ {
		if i%5 == 0 && i != 0 {
			name := sTemp[0]
			teacher := strings.Split(sTemp[1], "：")[1]
			date := strings.Split(sTemp[4], " ")[1] + " " + sTemp[2]
			addr := sTemp[3]
			strs := strings.Split(sTemp[2], " ")[0]
			switch strs {
			case "01~02小节":
				time = strings.Split(hsxy.HDL_1, "-")[0] + "-" + strings.Split(hsxy.HDL_2, "-")[1]
			case "03~04小节":
				time = strings.Split(hsxy.HDL_3, "-")[0] + "-" + strings.Split(hsxy.HDL_4, "-")[1]
			case "05~06小节":
				time = strings.Split(hsxy.HDL_5, "-")[0] + "-" + strings.Split(hsxy.HDL_6, "-")[1]
			case "07~08小节":
				time = strings.Split(hsxy.HDL_7, "-")[0] + "-" + strings.Split(hsxy.HDL_8, "-")[1]
			case "09~10~11小节":
				time = strings.Split(hsxy.HDL_9, "-")[0] + "-" + strings.Split(hsxy.HDL_11, "-")[1]
			}

			mTemp = map[string]string{
				"课程名称": name,
				"教师":   teacher,
				"时间":   time,
				"周次小节": date,
				"地点":   addr,
			}

			resTemp = append(resTemp, mTemp)
			sTemp = []string{}

		}
		
		if i != 65 {
			sTemp = append(sTemp, sechdule[i])
		}
		
	}

	result[key] = resTemp
	fmt.Println(len(resTemp))
	// fmt.Println(result)
}
